<?php

/*
Addon: Countdown WPB
*/

class CountdownWPB_Addon {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('countdownwpb_wpb_addon', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_script( 'countdown' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );			
		wp_enqueue_script( 'animate' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
        $date = '';

		extract(
			shortcode_atts(
				array(
					"countdown_year" => '',
					"countdown_month" => '',
					"countdown_day" => '',	
					"countdown_type" => 'type1',
					"countdown_style" => 'style1',
					"countdown_style_active" => 'off',
					"countdown_color" => '#FC615D',
					"countdown_secondary_color" => '#FC615D',
					"countdown_background_color" => '#FC615D',
					"countdown_font_size" => '',
					"countdown_padding" => '',
					"countdown_margin" => '',			
					"addon_animate" => 'off',
					"effect" => 'fade-in',
					"delay" => '0' 
					), 
					$atts)
		);

		wp_enqueue_script( 'countdown' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );			
		wp_enqueue_script( 'animate' );

		$return = '';
		
		if($countdown_type == 'type1') {		
			$return = '<script type=\'text/javascript\'>
						jQuery(document).ready(function($){
							$(\'.vcmp_clock.type1\').each(function() {
								var $this = $(this), finalDate = $(this).data(\'countdown\');
								$this.countdown(finalDate, function(event) {
									$this.html(event.strftime(\'<span class="vcmp-day">%D days</span> <span class="vcmp-time">%H:%M:%S</span>\'));
								});
							});
						});	
					   </script>';			   
		}
		
		if($countdown_type == 'type2') {
			$return = '<script type=\'text/javascript\'>
						jQuery(document).ready(function($){
							$(\'.vcmp_clock.type2\').each(function() {
								var $this = $(this), finalDate = $(this).data(\'countdown\');
								$this.countdown(finalDate, function(event) {
									$this.html(event.strftime(\'\'
										+ \'<span>%-w week%!w</span>\'
										+ \'<span>%-d day%!d</span>\'
										+ \'<span>%H hr</span>\'
										+ \'<span>%M min</span>\'
										+ \'<span>%S sec</span>\'));
								});
							});
						});	
					   </script>';
		}

		if($countdown_type == 'type3') {
			$return = '<script type=\'text/javascript\'>
						jQuery(document).ready(function($){
							$(\'#clock-'.$instance.'\').countdown("'.$countdown_year.'/'.$countdown_month.'/'.$countdown_day.'", function(event) {
							  var totalHours = event.offset.totalDays * 24 + event.offset.hours;
							  $(this).html(event.strftime(\'<span>\' + totalHours + \' hr</span> <span>%M min</span> <span>%S sec</span>\'));
							});
						});	
					   </script>';
		}
		
		if($countdown_style_active == 'on') {
			if($countdown_type == 'type1') {
				$return .= '<style type="text/css">';
				$return .= '.countdown-'.$instance.' .'.$countdown_type.'.'.$countdown_style.' { 
								font-size:'.$countdown_font_size.'; 
								color:'.$countdown_secondary_color.' 
							}'; 
				$return .= '.countdown-'.$instance.' .'.$countdown_type.'.'.$countdown_style.' .vcmp-day, 
							.countdown-'.$instance.' .'.$countdown_type.'.'.$countdown_style.' .vcmp-time {
								border-color:'.$countdown_color.';	
								padding:'.$countdown_padding.';
								background:'.$countdown_background_color.';
								margin:'.$countdown_margin.';								
							}';
				$return .= '</style>';		
			}
			if($countdown_type == 'type2' || $countdown_type == 'type3') {
				$return .= '<style type="text/css">';
				$return .= '.countdown-'.$instance.' .'.$countdown_type.'.'.$countdown_style.' { 
								font-size:'.$countdown_font_size.'; 
								color:'.$countdown_secondary_color.' 
							}'; 
				$return .= '.countdown-'.$instance.' .'.$countdown_type.'.'.$countdown_style.' span {
								border-color:'.$countdown_color.';	
								padding:'.$countdown_padding.';
								background:'.$countdown_background_color.';
								margin:'.$countdown_margin.';
							}';
				$return .= '</style>';		
			}		
		}
		
		if($addon_animate == 'on') {
			$return .=  '<div class="countdown-'.$instance.' animate-in" data-anim-type="'.$effect.'" data-anim-delay="'.$delay.'">';   
		} else {
			$return .= '<div class="countdown-'.$instance.'">';	
		}
		$return .= '<div id="clock-'.$instance.'" class="vcmp_clock '.$countdown_type.' '.$countdown_style.'" data-countdown="'.$countdown_year.'/'.$countdown_month.'/'.$countdown_day.'"></div><div class="adclear"></div>';	
		$return .= '</div>';
		
			
		return $return;
    }	



	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Countdown", "countdownwpb"),
                "base" => "countdownwpb_wpb_addon",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("Countdown", "countdownwpb"),
                'description' => esc_html__('add your Countdown', 'countdownwpb'),
                "icon" => COUNTDOWNWPB_URL . '/assets/img/vc-countdown.png',
                "params" => array(			
			  array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => __("Year (format: YYYY)",'countdownwpb'),
				  "param_name" => "countdown_year"				  
			  ),
			  array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => __("Month (format: MM)",'countdownwpb'),
				  "param_name" => "countdown_month"				  
			  ),
			  array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => __("Day (format: DD)",'countdownwpb'),
				  "param_name" => "countdown_day"				  
			  ),
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Type Coundown", 'countdownwpb'),
                  "param_name" => "countdown_type",
                  "value" => array(
									__('382 Days 05:44:12','countdownwpb') => 'type1',
									__('25 weeks 4 days 23 hr 57 min 56 sec','countdownwpb') 	  => 'type2',
									__('47 hr 59 min 14 sec','countdownwpb') => 'type3',
				   )
				),
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Style", 'countdownwpb'),
                  "param_name" => "countdown_style",
                  "value" => array(
									__('Style 1','countdownwpb') => 'style1',
									__('Style 2','countdownwpb') 	  => 'style2',
									__('Style 3','countdownwpb') => 'style3',
				   )
				),
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Active Custom Style", 'countdownwpb'),
                  "param_name" => "countdown_style_active",
                  "value" => array(
									__('Default style','countdownwpb')  	=> 'off',
									__('Custom Style','countdownwpb') 	=> 'on',
				  ),
				  "group" => "Style" 
				),				
				array(
					  "type" => "colorpicker",
					  "class" => "",
					  "heading" => __("Main Color", 'countdownwpb'),
					  "param_name" => "countdown_color",
					  "value" => '#FC615D',
					  "dependency" => array(
							'element' => 'countdown_style_active',
							'value' => array( 'on' )
					  ),					  
					  "group" => "Style"				  
				),
				array(
					  "type" => "colorpicker",
					  "class" => "",
					  "heading" => __("Secondary Color", 'countdownwpb'),
					  "param_name" => "countdown_secondary_color",
					  "value" => '#FC615D',
					  "dependency" => array(
							'element' => 'countdown_style_active',
							'value' => array( 'on' )
					  ),					  
					  "group" => "Style"				  
				),
				array(
					  "type" => "colorpicker",
					  "class" => "",
					  "heading" => __("Background Color", 'countdownwpb'),
					  "param_name" => "countdown_background_color",
					  "value" => '#FC615D',
					  "dependency" => array(
							'element' => 'countdown_style_active',
							'value' => array( 'on' )
					  ),					  
					  "group" => "Style"				  
				),				
			  	array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => __("Font Size",'countdownwpb'),
				  "param_name" => "countdown_font_size",
				  "description" => "ex 50px",
				  "dependency" => array(
							'element' => 'countdown_style_active',
							'value' => array( 'on' )
				  ),				  
				  "group" => "Style"					  		  
			  	),
			  	array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => __("Padding",'countdownwpb'),
				  "param_name" => "countdown_padding",
				  "description" => "ex 50px",
				  "dependency" => array(
							'element' => 'countdown_style_active',
							'value' => array( 'on' )
				  ),				  
				  "group" => "Style"					  		  
			  	),	
			  	array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => __("Margin",'countdownwpb'),
				  "param_name" => "countdown_margin",
				  "description" => "ex 50px",
				  "dependency" => array(
							'element' => 'countdown_style_active',
							'value' => array( 'on' )
				  ),				  
				  "group" => "Style"					  		  
			  	),					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'countdownwpb'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','countdownwpb') 	=> 'off',
										esc_html__('On','countdownwpb') 	=> 'on'
										
						),
						"dependency" => array(
							"element" => "pagination",
							"value" => array( "no", "yes" )
						),						
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'countdownwpb'),
						"param_name" => "effect",
						"value" => countdownwpb_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'countdownwpb'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_CountdownWPB_Addon extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('CountdownWPB_Addon')) {
    new CountdownWPB_Addon();
}